From ea91c36b325cefe01543a8549a86090b2ea50b29 Mon Sep 17 00:00:00 2001
From: Nigel Cunningham <nigelc@catalyst-au.net>
Date: Tue, 21 Apr 2015 16:02:11 +1000
Subject: [PATCH] Convert backup/restore to use MUC.

Convert the backup and restore code to use the Moodle Unified
Cache.

TODO:
- Update the Moodle1 converter.
- Tests still need to be modified.
- Some cleaning up around reset_backup_ids_cached
- Forward port to HEAD.

Signed-off-by: Nigel Cunningham <nigelc@catalyst-au.net>
---
 backup/converter/moodle1/lib.php                   |  28 +-
 .../moodle1/tests/moodle1_converter_test.php       |   6 -
 backup/moodle2/backup_stepslib.php                 | 134 ++++-----
 backup/moodle2/restore_plugin.class.php            |   2 +-
 backup/moodle2/restore_stepslib.php                | 275 ++++++++++-------
 backup/moodle2/restore_subplugin.class.php         |   2 +-
 backup/upgrade.txt                                 |   5 +
 .../util/dbops/backup_controller_dbops.class.php   |  88 ++----
 backup/util/dbops/backup_plan_dbops.class.php      |  29 +-
 backup/util/dbops/backup_question_dbops.class.php  |  45 +--
 backup/util/dbops/backup_structure_dbops.class.php |  59 ++--
 .../util/dbops/restore_controller_dbops.class.php  |  18 --
 backup/util/dbops/restore_dbops.class.php          | 330 ++++++++-------------
 backup/util/dbops/tests/restore_dbops_test.php     |  33 +--
 backup/util/helper/muc_helper.class.php            |  62 ++++
 .../util/helper/restore_decode_content.class.php   |  23 +-
 .../util/helper/restore_prechecks_helper.class.php |   2 +-
 backup/util/includes/backup_includes.php           |   1 +
 backup/util/includes/restore_includes.php          |   1 +
 backup/util/plan/restore_structure_step.class.php  |   2 +-
 .../util/structure/backup_nested_element.class.php |  69 +++++
 backup/util/structure/tests/structure_test.php     |  20 +-
 .../processors/grouped_parser_processor.class.php  |   9 +
 .../util/xml/parser/progressive_parser.class.php   |  14 +-
 .../moodle2/restore_html_block_task.class.php      |  35 ++-
 cache/classes/helper.php                           |   8 +-
 cache/classes/loaders.php                          |   2 +-
 cache/tests/cache_test.php                         |   5 +-
 local/automatedemails                              |   2 +-
 .../restore_qtype_multianswer_plugin.class.php     |  23 +-
 .../moodle2/restore_qtype_random_plugin.class.php  |  25 +-
 31 files changed, 733 insertions(+), 624 deletions(-)
 create mode 100644 backup/util/helper/muc_helper.class.php

diff --git a/backup/converter/moodle1/lib.php b/backup/converter/moodle1/lib.php
index 2f8232a..92e0dd3 100644
--- a/backup/converter/moodle1/lib.php
+++ b/backup/converter/moodle1/lib.php
@@ -417,25 +417,25 @@ class moodle1_converter extends base_converter {
     /**
      * Creates the temporary storage for stashed data
      *
-     * This implementation uses backup_ids_temp table.
+     * This implementation uses backup ids cache.
      */
     public function create_stash_storage() {
-        backup_controller_dbops::create_backup_ids_temp_table($this->get_id());
+        backup_controller_dbops::purge_backup_ids_temp_cache($this->get_id());
     }
 
     /**
      * Drops the temporary storage of stashed data
      *
-     * This implementation uses backup_ids_temp table.
+     * This implementation uses backup ids cache.
      */
     public function drop_stash_storage() {
-        backup_controller_dbops::drop_backup_ids_temp_table($this->get_id());
+        backup_controller_dbops::purge_backup_ids_temp_cache($this->get_id());
     }
 
     /**
      * Stores some information for later processing
      *
-     * This implementation uses backup_ids_temp table to store data. Make
+     * This implementation uses backup ids cache to store data. Make
      * sure that the $stashname + $itemid combo is unique.
      *
      * @param string $stashname name of the stash
@@ -495,13 +495,8 @@ class moodle1_converter extends base_converter {
      * @return array
      */
     public function get_stash_names() {
-        global $DB;
-
-        $search = array(
-            'backupid' => $this->get_id(),
-        );
-
-        return array_keys($DB->get_records('backup_ids_temp', $search, '', 'itemname'));
+        // @TODO
+        return $stashes;
     }
 
     /**
@@ -511,14 +506,7 @@ class moodle1_converter extends base_converter {
      * @return array
      */
     public function get_stash_itemids($stashname) {
-        global $DB;
-
-        $search = array(
-            'backupid' => $this->get_id(),
-            'itemname' => $stashname
-        );
-
-        return array_keys($DB->get_records('backup_ids_temp', $search, '', 'itemid'));
+        // @TODO
     }
 
     /**
diff --git a/backup/converter/moodle1/tests/moodle1_converter_test.php b/backup/converter/moodle1/tests/moodle1_converter_test.php
index 3209287..669b01e 100644
--- a/backup/converter/moodle1/tests/moodle1_converter_test.php
+++ b/backup/converter/moodle1/tests/moodle1_converter_test.php
@@ -88,12 +88,6 @@ class core_backup_moodle1_converter_testcase extends advanced_testcase {
         $this->assertInstanceOf('moodle1_converter', $converter);
     }
 
-    public function test_stash_storage_not_created() {
-        $converter = convert_factory::get_converter('moodle1', $this->tempdir);
-        $this->setExpectedException('moodle1_convert_storage_exception');
-        $converter->set_stash('tempinfo', 12);
-    }
-
     public function test_stash_requiring_empty_stash() {
         $this->resetAfterTest(true);
         $converter = convert_factory::get_converter('moodle1', $this->tempdir);
diff --git a/backup/moodle2/backup_stepslib.php b/backup/moodle2/backup_stepslib.php
index 4ba8223..49fa220 100644
--- a/backup/moodle2/backup_stepslib.php
+++ b/backup/moodle2/backup_stepslib.php
@@ -65,8 +65,6 @@ class create_and_clean_temp_stuff extends backup_execution_step {
         $progress->start_progress('Deleting backup directories');
         backup_helper::check_and_create_backup_dir($this->get_backupid());// Create backup temp dir
         backup_helper::clear_backup_dir($this->get_backupid(), $progress);           // Empty temp dir, just in case
-        backup_controller_dbops::drop_backup_ids_temp_table($this->get_backupid()); // Drop ids temp table
-        backup_controller_dbops::create_backup_ids_temp_table($this->get_backupid()); // Create ids temp table
         $progress->end_progress();
     }
 }
@@ -85,7 +83,6 @@ class drop_and_clean_temp_stuff extends backup_execution_step {
     protected function define_execution() {
         global $CFG;
 
-        backup_controller_dbops::drop_backup_ids_temp_table($this->get_backupid()); // Drop ids temp table
         backup_helper::delete_old_backup_dirs(strtotime('-1 week'));                // Delete > 1 week old temp dirs.
         // Delete temp dir conditionally:
         // 1) If $CFG->keeptempdirectoriesonbackup is not enabled
@@ -285,7 +282,7 @@ abstract class backup_questions_activity_structure_step extends backup_activity_
 /**
  * backup structure step in charge of calculating the categories to be
  * included in backup, based in the context being backuped (module/course)
- * and the already annotated questions present in backup_ids_temp
+ * and the already annotated questions present in backup_ids_temp cache
  */
 class backup_calculate_question_categories extends backup_execution_step {
 
@@ -296,7 +293,7 @@ class backup_calculate_question_categories extends backup_execution_step {
 
 /**
  * backup structure step in charge of deleting all the questions annotated
- * in the backup_ids_temp table
+ * in the backup ids cache
  */
 class backup_delete_temp_questions extends backup_execution_step {
 
@@ -660,12 +657,12 @@ class backup_final_roles_structure_step extends backup_structure_step {
 
         // Define sources
 
-        $role->set_source_sql("SELECT r.*, rn.name AS nameincourse
+        $role->set_source_sql_using_backup_ids(
+                              "SELECT r.*, rn.name AS nameincourse
                                  FROM {role} r
-                                 JOIN {backup_ids_temp} bi ON r.id = bi.itemid
                             LEFT JOIN {role_names} rn ON r.id = rn.roleid AND rn.contextid = ?
-                                WHERE bi.backupid = ?
-                                  AND bi.itemname = 'rolefinal'", array(backup::VAR_CONTEXTID, backup::VAR_BACKUPID));
+                                WHERE r.id *SQL*", array(backup::VAR_CONTEXTID),
+                                backup::VAR_BACKUPID, 'rolefinal', 'itemid');
 
         // Return main element (rolesdef)
         return $rolesdef;
@@ -694,11 +691,11 @@ class backup_final_scales_structure_step extends backup_structure_step {
 
         // Define sources
 
-        $scale->set_source_sql("SELECT s.*
+        $scale->set_source_sql_using_backup_ids(
+                               "SELECT s.*
                                   FROM {scale} s
-                                  JOIN {backup_ids_temp} bi ON s.id = bi.itemid
-                                 WHERE bi.backupid = ?
-                                   AND bi.itemname = 'scalefinal'", array(backup::VAR_BACKUPID));
+                                 WHERE s.id *SQL*", array(), backup::VAR_BACKUPID,
+                                   'scalefinal', 'itemid');
 
         // Annotate scale files (they store files in system context, so pass it instead of default one)
         $scale->annotate_files('grade', 'scale', 'id', context_system::instance()->id);
@@ -731,11 +728,11 @@ class backup_final_outcomes_structure_step extends backup_structure_step {
 
         // Define sources
 
-        $outcome->set_source_sql("SELECT o.*
+        $outcome->set_source_sql_using_backup_ids(
+                                 "SELECT o.*
                                     FROM {grade_outcomes} o
-                                    JOIN {backup_ids_temp} bi ON o.id = bi.itemid
-                                   WHERE bi.backupid = ?
-                                     AND bi.itemname = 'outcomefinal'", array(backup::VAR_BACKUPID));
+                                   WHERE o.id ", array(), backup::VAR_BACKUPID,
+                                     'outcomefinal', 'itemid');
 
         // Annotate outcome files (they store files in system context, so pass it instead of default one)
         $outcome->annotate_files('grade', 'outcome', 'id', context_system::instance()->id);
@@ -1131,24 +1128,22 @@ class backup_groups_structure_step extends backup_structure_step {
 
         // Define sources
 
-        $group->set_source_sql("
+        $group->set_source_sql_using_backup_ids("
             SELECT g.*
               FROM {groups} g
-              JOIN {backup_ids_temp} bi ON g.id = bi.itemid
-             WHERE bi.backupid = ?
-               AND bi.itemname = 'groupfinal'", array(backup::VAR_BACKUPID));
+             WHERE g.id *SQL*", array(), backup::VAR_BACKUPID,
+               'groupfinal', 'itemid');
 
         // This only happens if we are including users
         if ($users) {
             $member->set_source_table('groups_members', array('groupid' => backup::VAR_PARENTID));
         }
 
-        $grouping->set_source_sql("
+        $grouping->set_source_sql_using_backup_ids("
             SELECT g.*
               FROM {groupings} g
-              JOIN {backup_ids_temp} bi ON g.id = bi.itemid
-             WHERE bi.backupid = ?
-               AND bi.itemname = 'groupingfinal'", array(backup::VAR_BACKUPID));
+             WHERE g.id *SQL*", array(), backup::VAR_BACKUPID,
+               'groupingfinal', 'itemid');
 
         $groupinggroup->set_source_table('groupings_groups', array('groupingid' => backup::VAR_PARENTID));
 
@@ -1281,15 +1276,12 @@ class backup_users_structure_step extends backup_structure_step {
 
         // Define sources
 
-        $user->set_source_sql('SELECT u.*, c.id AS contextid, m.wwwroot AS mnethosturl
+        $user->set_source_sql_using_backup_ids(
+                              'SELECT u.*, c.id AS contextid, m.wwwroot AS mnethosturl
                                  FROM {user} u
-                                 JOIN {backup_ids_temp} bi ON bi.itemid = u.id
                             LEFT JOIN {context} c ON c.instanceid = u.id AND c.contextlevel = ' . CONTEXT_USER . '
                             LEFT JOIN {mnet_host} m ON m.id = u.mnethostid
-                                WHERE bi.backupid = ?
-                                  AND bi.itemname = ?', array(
-                                      backup_helper::is_sqlparam($this->get_backupid()),
-                                      backup_helper::is_sqlparam('userfinal')));
+                                WHERE u.id *SQL*', array(), $this->get_backupid(), 'userfinal', 'itemid');
 
         // All the rest on information is only added if we arent
         // in an anonymized backup
@@ -1479,12 +1471,7 @@ class backup_inforef_structure_step extends backup_structure_step {
                 $element = new backup_nested_element($itemname, array(), array('id'));
                 $inforef->add_child($elementroot);
                 $elementroot->add_child($element);
-                $element->set_source_sql("
-                    SELECT itemid AS id
-                     FROM {backup_ids_temp}
-                    WHERE backupid = ?
-                      AND itemname = ?",
-                   array(backup::VAR_BACKUPID, backup_helper::is_sqlparam($itemname)));
+                $element->set_source_cache($itemname);
             }
         }
 
@@ -1545,14 +1532,14 @@ class backup_final_files_structure_step extends backup_structure_step {
 
         // Define sources
 
-        $file->set_source_sql("SELECT f.*, r.type AS repositorytype, fr.repositoryid, fr.reference
+        $file->set_source_sql_using_backup_ids(
+                              "SELECT f.*, r.type AS repositorytype, fr.repositoryid, fr.reference
                                  FROM {files} f
                                       LEFT JOIN {files_reference} fr ON fr.id = f.referencefileid
                                       LEFT JOIN {repository_instances} ri ON ri.id = fr.repositoryid
                                       LEFT JOIN {repository} r ON r.id = ri.typeid
-                                      JOIN {backup_ids_temp} bi ON f.id = bi.itemid
-                                WHERE bi.backupid = ?
-                                  AND bi.itemname = 'filefinal'", array(backup::VAR_BACKUPID));
+                                WHERE f.id *SQL*", array(), backup::VAR_BACKUPID,
+                                     'filefinal', 'itemid');
 
         return $files;
     }
@@ -1851,14 +1838,13 @@ class backup_annotate_groups_from_groupings extends backup_execution_step {
         global $DB;
 
         // Fetch all the annotated groupings
-        if ($groupings = $DB->get_records('backup_ids_temp', array(
-                'backupid' => $this->get_backupid(), 'itemname' => 'grouping'))) {
-            foreach ($groupings as $grouping) {
-                if ($groups = $DB->get_records('groupings_groups', array(
-                        'groupingid' => $grouping->itemid))) {
-                    foreach ($groups as $group) {
-                        backup_structure_dbops::insert_backup_ids_record($this->get_backupid(), 'group', $group->groupid);
-                    }
+        $cache = backup_muc_manager::get('grouping');
+        $groupings = $cache->get_store()->find_all();
+        foreach ($groupings as $grouping) {
+            if ($groups = $DB->get_records('groupings_groups', array(
+                            'groupingid' => $grouping))) {
+                foreach ($groups as $group) {
+                    backup_structure_dbops::insert_backup_ids_record($this->get_backupid(), 'group', $group->groupid);
                 }
             }
         }
@@ -1874,14 +1860,13 @@ class backup_annotate_scales_from_outcomes extends backup_execution_step {
         global $DB;
 
         // Fetch all the annotated outcomes
-        if ($outcomes = $DB->get_records('backup_ids_temp', array(
-                'backupid' => $this->get_backupid(), 'itemname' => 'outcome'))) {
-            foreach ($outcomes as $outcome) {
-                if ($scale = $DB->get_record('grade_outcomes', array(
-                        'id' => $outcome->itemid))) {
-                    // Annotate as scalefinal because it's > 0
-                    backup_structure_dbops::insert_backup_ids_record($this->get_backupid(), 'scalefinal', $scale->scaleid);
-                }
+        $cache = backup_muc_manager::get('outcome');
+        $outcomes = $cache->get_store()->find_all();
+        foreach ($outcomes as $outcome) {
+            if ($scale = $DB->get_record('grade_outcomes', array(
+                            'id' => $outcome))) {
+                // Annotate as scalefinal because it's > 0
+                backup_structure_dbops::insert_backup_ids_record($this->get_backupid(), 'scalefinal', $scale->scaleid);
             }
         }
     }
@@ -1902,11 +1887,18 @@ class backup_annotate_all_question_files extends backup_execution_step {
 
         // Get all the different contexts for the final question_categories
         // annotated along the whole backup
+        $cache = backup_muc_manager::get('question_categoryfinal');
+        $cache_content = $cache->get_store()->find_all();
+
+        if (empty($cache_content)) {
+            return;
+        }
+
+        list($sql, $params) = $DB->get_in_or_equal($cache_content);
+
         $rs = $DB->get_recordset_sql("SELECT DISTINCT qc.contextid
                                         FROM {question_categories} qc
-                                        JOIN {backup_ids_temp} bi ON bi.itemid = qc.id
-                                       WHERE bi.backupid = ?
-                                         AND bi.itemname = 'question_categoryfinal'", array($this->get_backupid()));
+                                       WHERE qc.id $sql", $params);
         // To know about qtype specific components/fileareas
         $components = backup_qtype_plugin::get_components_and_fileareas();
         // Let's loop
@@ -1989,13 +1981,12 @@ class backup_questions_structure_step extends backup_structure_step {
 
         // Define the sources
 
-        $qcategory->set_source_sql("
+        $qcategory->set_source_sql_using_backup_ids("
             SELECT gc.*, contextlevel, instanceid AS contextinstanceid
               FROM {question_categories} gc
-              JOIN {backup_ids_temp} bi ON bi.itemid = gc.id
               JOIN {context} co ON co.id = gc.contextid
-             WHERE bi.backupid = ?
-               AND bi.itemname = 'question_categoryfinal'", array(backup::VAR_BACKUPID));
+             WHERE gc.id *SQL*", array(), backup::VAR_BACKUPID,
+               'question_categoryfinal', 'itemid');
 
         $question->set_source_table('question', array('category' => backup::VAR_PARENTID));
 
@@ -2037,12 +2028,11 @@ class backup_annotate_all_user_files extends backup_execution_step {
         $fileareas = array('profile', 'icon');
 
         // Fetch all annotated (final) users
-        $rs = $DB->get_recordset('backup_ids_temp', array(
-            'backupid' => $this->get_backupid(), 'itemname' => 'userfinal'));
+        $cache = backup_muc_manager::get('userfinal');
+        $cache_content = $cache->get_store()->find_all();
         $progress = $this->task->get_progress();
         $progress->start_progress($this->get_name());
-        foreach ($rs as $record) {
-            $userid = $record->itemid;
+        foreach ($cache_content as $userid) {
             $userctx = context_user::instance($userid, IGNORE_MISSING);
             if (!$userctx) {
                 continue; // User has not context, sure it's a deleted user, so cannot have files
@@ -2056,7 +2046,6 @@ class backup_annotate_all_user_files extends backup_execution_step {
             }
         }
         $progress->end_progress();
-        $rs->close();
     }
 }
 
@@ -2190,11 +2179,10 @@ class backup_activity_grades_structure_step extends backup_structure_step {
 
         // Define sources
 
-        $item->set_source_sql("SELECT gi.*
+        $item->set_source_sql_using_backup_ids("SELECT gi.*
                                FROM {grade_items} gi
-                               JOIN {backup_ids_temp} bi ON gi.id = bi.itemid
-                               WHERE bi.backupid = ?
-                               AND bi.itemname = 'grade_item'", array(backup::VAR_BACKUPID));
+                               WHERE gi.id *SQL*", array(), backup::VAR_BACKUPID,
+                               'grade_item', 'itemid');
 
         // This only happens if we are including user info
         if ($userinfo) {
diff --git a/backup/moodle2/restore_plugin.class.php b/backup/moodle2/restore_plugin.class.php
index b90bcdf..fcded87 100644
--- a/backup/moodle2/restore_plugin.class.php
+++ b/backup/moodle2/restore_plugin.class.php
@@ -170,7 +170,7 @@ abstract class restore_plugin {
      * To send ids pairs to backup_ids_table and to store them into paths
      *
      * This method will send the given itemname and old/new ids to the
-     * backup_ids_temp table, and, at the same time, will save the new id
+     * backup ids cache, and, at the same time, will save the new id
      * into the corresponding restore_path_element for easier access
      * by children. Also will inject the known old context id for the task
      * in case it's going to be used for restoring files later
